package me.wazup.hideandseek;

import java.util.Optional;
import java.util.Iterator;
import org.bukkit.configuration.file.FileConfiguration;
import me.wazup.hideandseek.xseries.XSound;
import org.bukkit.ChatColor;
import me.wazup.hideandseek.utils.ItemStackBuilder;
import me.wazup.hideandseek.xseries.XMaterial;
import java.util.TreeMap;
import java.util.Collection;
import me.wazup.hideandseek.utils.Utils;
import org.bukkit.Sound;
import org.bukkit.inventory.ItemStack;
import java.util.HashMap;
import java.util.Map;
import java.util.ArrayList;
import java.util.List;

public class Config
{
    public boolean trailsEnabled;
    public boolean bungeeEnabled;
    public boolean mysql_enabled;
    public boolean FallDamageEnabled;
    public boolean FireworkDamageEnabled;
    boolean useUUID;
    boolean useVault;
    int StartingHiderChance;
    int EndingLength;
    public int LeapCooldown;
    public double leapMultiplier;
    public int ThrowabbleTNTCooldown;
    public int DisguiseDetectorCooldown;
    int SeekersInitialSpawnDelay;
    int SeekersRespawnDelay;
    boolean UpdateBlockBehindSign;
    boolean AntiSeekerQuit;
    int AntiSeekerQuitActivationHidersRequired;
    boolean JoinGuiEnabled;
    boolean rewardStartingSeekers;
    boolean TeleportToGlobalLobbyOnLeave;
    boolean DisplayArenaStateOnBlock;
    public boolean modifychat;
    boolean arenaScoreboardEnabled;
    public String chatModification;
    public int HiderKillSeekerEarnedCoins;
    public int SeekerKillHiderEarnedCoins;
    public int HiderKillSeekerMinEarnedExp;
    public int HiderKillSeekerMaxEarnedExp;
    public int SeekerKillHiderMinEarnedExp;
    public int SeekerKillHiderMaxEarnedExp;
    public int minKarmaForSayingGG;
    public int maxKarmaForSayingGG;
    int coinsTimerGiveEvery;
    int coinsTimerAmount;
    List<String> commandsExecutedOnWinners;
    List<String> commandsExecutedOnLosers;
    int fireworksAmountPerGame;
    public int fireworksGivenCoins;
    public int fireworksCooldown;
    int fireworksDelayInBetween;
    public int trailsSize;
    public int trailsInterval;
    int bungee_amount_of_games_till_restart;
    ArrayList<String> bungee_executed_commands_to_restart;
    String mysql_table;
    String mysql_host;
    String mysql_port;
    String mysql_database;
    String mysql_username;
    String mysql_password;
    public Map<Integer, Integer> shopChances;
    public HashMap<ItemStack, Integer> shopSpecial;
    public ArrayList<String> allowedCommands;
    ArrayList<String> executedCmds_arenaStart;
    ArrayList<String> executedCmds_arenaCountdown;
    ArrayList<Integer> ArenaStartWarnAt;
    public int powerup_coins_min;
    public int powerup_coins_max;
    public boolean karmaEnabled;
    boolean sendMessageOnSeekersRelease;
    boolean playAgainMessage;
    String playAgainHeader;
    String playAgainFooter;
    List<String> playAgainContent;
    public HashMap<String, Sound> sounds;
    public HashMap<String, Integer> arenaHotbarItems;
    private static Config instance;
    
    public static Config getInstance() {
        return Config.instance;
    }
    
    public Config() {
        Config.instance = this;
    }
    
    public void load(final HideAndSeek hideAndSeek) {
        final FileConfiguration config = hideAndSeek.getConfig();
        this.FallDamageEnabled = config.getBoolean("Fall-Damage-Enabled");
        this.FireworkDamageEnabled = config.getBoolean("Firework-Damage-Enabled");
        this.useUUID = config.getBoolean("use-UUID");
        this.useVault = config.getBoolean("use-Vault");
        this.StartingHiderChance = config.getInt("Starting-Hider-Chance");
        this.EndingLength = config.getInt("Ending-Length");
        this.LeapCooldown = config.getInt("Leap-Cooldown");
        this.leapMultiplier = config.getDouble("Leap-Multiplier");
        this.ThrowabbleTNTCooldown = config.getInt("Throwable-Tnt-Cooldown");
        this.DisguiseDetectorCooldown = config.getInt("Disguise-Detector-Cooldown");
        this.SeekersInitialSpawnDelay = config.getInt("Seekers-Initial-Spawn-Delay") * 20;
        this.SeekersRespawnDelay = config.getInt("Seekers-Respawn-Delay") * 20;
        this.UpdateBlockBehindSign = config.getBoolean("Update-Block-Behind-Sign");
        this.AntiSeekerQuit = config.getBoolean("Anti-Seeker-Quit");
        this.AntiSeekerQuitActivationHidersRequired = config.getInt("Anti-Seeker-Quit-Activation-Hiders-Required") - 1;
        this.JoinGuiEnabled = config.getBoolean("Join-Gui-Enabled");
        this.rewardStartingSeekers = config.getBoolean("Reward-Starting-Seekers");
        this.TeleportToGlobalLobbyOnLeave = config.getBoolean("Teleport-To-Global-Lobby-On-Leave");
        this.arenaScoreboardEnabled = config.getBoolean("Arena-Scoreboard-Enabled");
        this.DisplayArenaStateOnBlock = config.getBoolean("Display-Arena-State-On-Block");
        this.modifychat = config.getBoolean("Modify-Chat");
        this.chatModification = Utils.colorize(config.getString("Chat-Modification"));
        this.HiderKillSeekerEarnedCoins = config.getInt("Coins-Earned.Hider-Kill-Seeker");
        this.SeekerKillHiderEarnedCoins = config.getInt("Coins-Earned.Seeker-Kill-Hider");
        this.HiderKillSeekerMinEarnedExp = config.getInt("Exp-Earned.Hider-Kill-Seeker.Min");
        this.HiderKillSeekerMaxEarnedExp = config.getInt("Exp-Earned.Hider-Kill-Seeker.Max");
        this.SeekerKillHiderMinEarnedExp = config.getInt("Exp-Earned.Seeker-Kill-Hider.Min");
        this.SeekerKillHiderMaxEarnedExp = config.getInt("Exp-Earned.Seeker-Kill-Hider.Max");
        this.minKarmaForSayingGG = config.getInt("Karma-Earned.Saying-GG.Min");
        this.maxKarmaForSayingGG = config.getInt("Karma-Earned.Saying-GG.Max");
        this.coinsTimerGiveEvery = config.getInt("Coins-Timer.Give-Coins-Every-In-Seconds");
        this.coinsTimerAmount = config.getInt("Coins-Timer.Amount");
        this.commandsExecutedOnWinners = config.getStringList("Commands-Executed-On-Winners");
        this.commandsExecutedOnLosers = config.getStringList("Commands-Executed-On-Losers");
        this.fireworksAmountPerGame = config.getInt("Fireworks.Amount-Per-Game");
        this.fireworksGivenCoins = config.getInt("Fireworks.Given-Coins");
        this.fireworksCooldown = config.getInt("Fireworks.Cooldown");
        this.fireworksDelayInBetween = config.getInt("Fireworks.Delay-In-Between");
        this.trailsEnabled = config.getBoolean("Trails.enabled");
        this.trailsSize = config.getInt("Trails.size");
        this.trailsInterval = config.getInt("Trails.interval");
        this.bungeeEnabled = config.getBoolean("BungeeMode.enabled");
        this.bungee_amount_of_games_till_restart = config.getInt("BungeeMode.amount_of_games_till_restart");
        this.bungee_executed_commands_to_restart = new ArrayList<String>(config.getStringList("BungeeMode.executed_commands_to_restart"));
        this.mysql_enabled = config.getBoolean("MySQL.enabled");
        this.mysql_table = config.getString("MySQL.table");
        this.mysql_host = config.getString("MySQL.host");
        this.mysql_port = config.getString("MySQL.port");
        this.mysql_database = config.getString("MySQL.database");
        this.mysql_username = config.getString("MySQL.username");
        this.mysql_password = config.getString("MySQL.password");
        final HashMap m = new HashMap();
        for (final String s : config.getStringList("Shop.Chances")) {
            m.put((int)Integer.valueOf(s.split(":")[0]), (int)Integer.valueOf(s.split(":")[1]));
        }
        this.shopChances = new TreeMap<Integer, Integer>(m);
        this.shopSpecial = new HashMap<ItemStack, Integer>();
        final Iterator iterator2 = config.getStringList("Shop.Special_Blocks").iterator();
        while (iterator2.hasNext()) {
            final String[] split = ((String)iterator2.next()).split(" : ");
            this.shopSpecial.put(new ItemStackBuilder(((XMaterial)XMaterial.matchXMaterial(split[0]).get()).parseItem()).setName(ChatColor.GOLD + "Special block").build(), Integer.parseInt(split[1]));
        }
        this.allowedCommands = new ArrayList<String>();
        final Iterator iterator3 = config.getStringList("Allowed-Commands").iterator();
        while (iterator3.hasNext()) {
            this.allowedCommands.add(((String)iterator3.next()).toLowerCase());
        }
        this.executedCmds_arenaStart = new ArrayList<String>(config.getStringList("Executed-Commands.Arena-Start"));
        this.executedCmds_arenaCountdown = new ArrayList<String>(config.getStringList("Executed-Commands.Arena-Countdown"));
        (this.ArenaStartWarnAt = new ArrayList<Integer>()).addAll(config.getIntegerList("Arena-Starting-Warn-At"));
        this.powerup_coins_min = config.getInt("Powerups.coins.min");
        this.powerup_coins_max = config.getInt("Powerups.coins.max");
        this.karmaEnabled = config.getBoolean("Karma-Enabled");
        this.sendMessageOnSeekersRelease = config.getBoolean("Send-Message-On-Seekers-Release");
        this.playAgainMessage = config.getBoolean("Play-Again-Message.enabled");
        if (this.playAgainMessage) {
            this.playAgainHeader = Utils.colorize(config.getString("Play-Again-Message.header"));
            this.playAgainContent = new ArrayList<String>();
            final Iterator iterator4 = config.getStringList("Play-Again-Message.content").iterator();
            while (iterator4.hasNext()) {
                this.playAgainContent.add(Utils.colorize((String)iterator4.next()));
            }
            this.playAgainFooter = Utils.colorize(config.getString("Play-Again-Message.footer"));
        }
        if (config.contains("Sounds.onHit")) {
            config.set("Sounds.onHit", (Object)null);
            hideAndSeek.saveConfig();
        }
        this.arenaHotbarItems = new HashMap<String, Integer>();
        for (final String str : config.getConfigurationSection("Hotbar-Items.Arena").getKeys(false)) {
            if (config.getBoolean("Hotbar-Items.Arena." + str + ".enabled")) {
                this.arenaHotbarItems.put(str, config.getInt("Hotbar-Items.Arena." + str + ".slot") - 1);
            }
        }
        this.sounds = new HashMap<String, Sound>();
        for (final String s2 : config.getConfigurationSection("Sounds").getKeys(false)) {
            if (config.getBoolean("Sounds." + s2 + ".enabled")) {
                final String string = config.getString("Sounds." + s2 + ".sound");
                final Optional matchXSound = XSound.matchXSound(string);
                if (matchXSound.isPresent()) {
                    this.sounds.put(s2, ((XSound)matchXSound.get()).parseSound());
                }
                else {
                    Utils.error("Could not find a sound named " + string + ". " + s2 + " sound will not be played");
                }
            }
        }
    }
}
